Subject: RE: [External] : Re: bug#46973: 26.3; (elisp) `Face Remapping'

From: Drew Adams <[email-masked]>
Date: Mon, 15 Mar 2021 16:36:03 +0000

> > But if I do something like this, where SPECS (being a &rest arg) is the
> list `(variable-pitch)', which is a list of face names:
> >
> > (add-hook 'some-mode-hook
> >           (lambda ()
> >             (face-remap-set-base 'default 'variable-pitch)))
> >
> > I get an error saying that `variable-pitch' isn't a list.
> > (And trying '(variable-pitch) instead gives the same error.)
> >
> > I'm probably missing something - what is it?  Or is it possible that
> > `face-remap-set-base' has a different meaning of SPECS?
> 
> The doc string of face-remap-set-base says:
> 
>   The remaining arguments, SPECS, specify the base of the remapping.
>   Each one of SPECS should be either a face name or a property list
>   of face attribute/value pairs, like in a ‘face’ text property.

You just cited the same doc I cited.

In `(face-remap-set-base 'default 'variable-pitch)' do
you not agree that SPECS is the list `(variable-pitch)',
which is a list of one face name?

Again, what am I missing?

 M-x debug-on-entry face-remap-set-base

Stepping through shows that SPECS is indeed the list
`(variable-pitch)'.  The first (and only) spec is the
face (name) `variable-pitch'.

To me, it looks like either a doc bug or a code bug.
The `while' loop sets SPECS to `variable-pitch'.  And
the subsequent `if' tries to take its car.

Contrast with `face-remap-add-relative', which also
has an &rest SPECS arg, and whose elements can also
each be "a face name or a property list of face
attribute/value pairs."

The code for `face-remap-add-relative' does this:

  (while (and (consp specs) (null (cdr specs)))
    (setq specs (car specs)))

which is different from what `face-remap-set-base' does:

  (while (and (consp specs)
              (not (null (car specs)))
              (null (cdr specs)))
    (setq specs (car specs)))

I'm not saying that the two should necessarily be
the same.  I am saying that the latter doesn't
seem to work for SPECS that's a list of face names.